<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Remote\FileUploader\Server;


class crm20000CasoAnexosController extends SMCrud
{
    protected $dataSourceName = 'crm_anexocontato';
    
    protected $zhFileUploader;
    protected $newCode;
    protected $anexosCasoService;
    
    public function __construct($crudService, $environment, Server $zhFileUploader, $newCode, $anexosCasoService) {
        
		$this->zhFileUploader       = $zhFileUploader;
		$this->newCode              = $newCode; 
		$this->anexosCasoService    = $anexosCasoService;

    	parent::__construct($crudService, $environment);
	}
    
    public function save(Request $request, Response $response) {
        
        $rows = $request->getDataSet()->getRows();
        $index = 0;
        foreach ($rows as &$row) {
            $row["DSCAMINHO"] = $row["DSCAMINHO"][$index++]["path"];
            $row["NRANEXOCONTATO"] = $this->newCode->getCodeByTableName("CRM_ANEXOCONTATO", $row["NRORG"]);
        }
        
        parent::save($request, $response);
        
    }
     public function saveAnexo(Request $request, Response $response) {
        $rows = $request->getDataSet()->getRows();
        foreach ($rows as $row) {
            
            $nrseqcontato = $row["NRSEQCONTATO"];
            $nmarquivo = $row["NMARQUIVO"];
            $dscaminho = $row["DSCAMINHOARQ"];
            $dstipo = $row["DSTIPO"];
            $vrtamanho = $row["VRTAMANHO"];
            $idativo = "S";
            $nrorg = $this->environment->getNrOrg();
            $nrorginclusao = $this->environment->getNrOrg();
            $cdoperinclusao = $row["OPERADOR"];
            $dtultatu = null;
            $nrorgultatu = null;
            $cdoperultatu = null;
            $idorigem = "EVOLUCAO";
            $nrorigem = $row["NRSEQEVOLCONT"];
            $nranexocontato = $this->newCode->getCodeByTableName("CRM_ANEXOCONTATO", $nrorg);
            
            $this->anexosCasoService->saveAnexo($nranexocontato, $nrseqcontato, $nmarquivo, $dscaminho, $dstipo, $vrtamanho, $idativo, $nrorg, $nrorginclusao, $cdoperinclusao, $dtultatu, $nrorgultatu, $cdoperultatu, $idorigem, $nrorigem);
        }
        
    }
    
    public function delete(Request $request, Response $response){
        
        $row = $request->getRow();
        
        $this->zhFileUploader->deleteFile($row["DSCAMINHO"]);
        
        parent::delete($request, $response);
        
    }
    
    public function deleteFilesByOriginNumber(Row $row){
        
        $row = $row->getRow();
        
        $fileUrls = self::getFilesUrlByOriginNumber($row);
        
        if($fileUrls){
            
            foreach ($fileUrls as $url) {
                
                $this->zhFileUploader->deleteFile($url["DSCAMINHO"]); 
                
            }
            
        }
        
        $this->anexosCasoService->callForDeleteFilesByOriginNumber($row);
        
    }
    
    public function getFilesUrlByOriginNumber($row){
        
        $fileUrls = $this->anexosCasoService->callForGetFilesUrlByOriginNumber($row);
        
        return $fileUrls;
    }
    
}
?>
