<?php

namespace Teknisa\SM\Service;
use Teknisa\Libs\Util\Environment;
use Teknisa\SM\Factory\Sm00031000MapaRecursosAgendadosFactory;

class Sm00031000MapaRecursosAgendadosService
{
    protected $mapaFactory;
    protected $Environment;
    
    public function __construct (Sm00031000MapaRecursosAgendadosFactory $mapaFactory, Environment $Environment) {
        $this->mapaFactory = $mapaFactory;
        $this->Environment  = $Environment;
    }
    
    /**
    *  A função que busca o recursos agendados para ser mostrados no Swipe para cada marcador no mapa.
    * Têm com entrada o local de atendimento retorna os recursos deste local 
    */
    
    public function getRecursos($localDeatendimento){
    
        $params = array(
            "NRSEQCONTRATO" => $localDeatendimento,
            "NRORG"         => $this->Environment->getNrOrg()
        );
        
        $recursos = $this->mapaFactory->getRecursos($params);
        return $recursos;
    
    }
    }
?>